/**
 * 
 */
package eu.etaxonomy.taxeditor.editor.key.polytomous;

import java.util.UUID;

import eu.etaxonomy.cdm.api.conversation.ConversationHolder;
import eu.etaxonomy.cdm.api.service.IPolytomousKeyService;
import eu.etaxonomy.cdm.model.description.PolytomousKey;
import eu.etaxonomy.taxeditor.editor.key.AbstractIdentificationEditorInput;
import eu.etaxonomy.taxeditor.store.CdmStore;

/**
 * @author n.hoffmann
 *
 */
public class PolytomousKeyEditorInput extends AbstractIdentificationEditorInput<PolytomousKey> {

	private PolytomousKey key;

	protected PolytomousKeyEditorInput(ConversationHolder conversation,
			PolytomousKey key) {
		super(conversation);
		this.key = key;
	}
	
	

	public static PolytomousKeyEditorInput NewInstance(UUID polytomousKeyUuid) throws Exception{
		try{
			ConversationHolder conversation = CdmStore.createConversation();
						
			return NewInstance(polytomousKeyUuid, conversation);
		}catch(Exception e){
			throw e;
		}
	}
	
	public static PolytomousKeyEditorInput NewInstance(UUID polytomousKeyUuid, ConversationHolder conversation) throws Exception{
		PolytomousKey polytomousKey = CdmStore.getService(IPolytomousKeyService.class).load(polytomousKeyUuid, null);
			
		return new PolytomousKeyEditorInput(conversation, polytomousKey);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.ui.IEditorInput#getName()
	 */
	@Override
	public String getName() {
		return key.getTitleCache();
	}
	
	@Override
	public PolytomousKey getKey() {
		return key;
	}
	
	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object object) {
		if (object instanceof PolytomousKeyEditorInput
				&& getKey() != null
				&& getKey().equals(((PolytomousKeyEditorInput) object).getKey())
		){
			return true;
		}
		return super.equals(object);
	}
}
