/**
 *
 */
package eu.etaxonomy.taxeditor.editor.view.derivate;

import org.eclipse.core.expressions.PropertyTester;
import org.eclipse.jface.viewers.IStructuredSelection;

import eu.etaxonomy.cdm.model.molecular.Amplification;
import eu.etaxonomy.cdm.model.molecular.Sequence;
import eu.etaxonomy.cdm.model.occurrence.SpecimenOrObservationBase;

/**
 * Property tester used by the DerivateView tree menu.
 *
 */
public class DerivateMenuPropertyTester extends PropertyTester {

	private static final String IS_SPECIMEN_OR_OBSERVATION = "isSpecimenOrObservation";

	/* (non-Javadoc)
	 * @see org.eclipse.core.expressions.IPropertyTester#test(java.lang.Object, java.lang.String, java.lang.Object[], java.lang.Object)
	 */
	/** {@inheritDoc} */
	@Override
    public boolean test(Object receiver, String property, Object[] args, Object expectedValue) {
	    //TODO: these simple instanceof-checks can be unified in one class because there are several
	    // PropertyTesters that do the same, that is just checking which class the selection is of

	    Object[] selectedElements = ((IStructuredSelection) receiver).toArray();

		if(selectedElements.length == 0){
			// nothing selected so all tests should fail
			return false;
		}

		if(IS_SPECIMEN_OR_OBSERVATION.equals(property)){
		    return isSpecimenOrObservation(selectedElements);
		}
		else{
			return false;
		}
	}

	private boolean isSpecimenOrObservation(Object[] selectedElements) {
	    for (Object object : selectedElements){
	        if(!(object instanceof SpecimenOrObservationBase || object instanceof Amplification || object instanceof Sequence)){
	            return false;
	        }
	    }
	    return true;
	}

}
